#!/usr/bin/env python

"""
This test attempts to guard 'obj' in 'test_one' with only an instance check for
D instances. In the process, the unused methods should be discarded.
"""

class C:
    def f(self): # unused
        return 1

class D:
    def f(self):
        return 2

    def __init__(self, g):
        self.g = g

class E:
    def f(self): # unused
        return 4

    def h(self): # unused
        return 5

def test_one(obj):
                    # obj: f, g
    obj.f()
    return obj.g

c = C()
d = D(4)
e = E()
result1_4 = test_one(d)

# vim: tabstop=4 expandtab shiftwidth=4
